Index: ui/tool/kis_tool_freehand.cc
===================================================================
--- ui/tool/kis_tool_freehand.cc	(revision 1177751)
+++ ui/tool/kis_tool_freehand.cc	(working copy)
@@ -24,64 +24,49 @@
 #include "kis_tool_freehand.h"
 #include "kis_tool_freehand_p.h"
 
-#include <QEvent>
-#include <QLabel>
-#include <QLayout>
-#include <QMutex>
-#include <QMutexLocker>
-#include "QPainter"
+#include <QPainter>
 #include <QRect>
 #include <QThreadPool>
-#include <QWidget>
 
-#include <klocale.h>
 #include <kaction.h>
 
 #include <KoPointerEvent.h>
-#include <KoCanvasBase.h>
-#include <KoResourceManager.h>
-#include <KoCanvasController.h>
 #include <KoViewConverter.h>
 
 //pop up palette
-#include <ko_favorite_resource_manager.h>
 #include <kis_canvas_resource_provider.h>
 
 // Krita/image
 #include <recorder/kis_action_recorder.h>
-#include <kis_fill_painter.h>
-#include <kis_group_layer.h>
+#include <recorder/kis_recorded_path_paint_action.h>
 #include <kis_layer.h>
 #include <kis_paint_layer.h>
 #include <kis_painter.h>
 #include <kis_paintop.h>
-#include <recorder/kis_recorded_path_paint_action.h>
 #include <kis_selection.h>
 #include <kis_paintop_preset.h>
-#include <kis_debug.h>
-#include <kis_transaction.h>
 
+
 // Krita/ui
 #include "kis_config.h"
 #include <opengl/kis_opengl.h>
 #include "canvas/kis_canvas2.h"
 #include "kis_cursor.h"
-#include "kis_painting_assistant.h"
 #include <recorder/kis_node_query_path.h>
 #include <kis_view2.h>
 #include <kis_painting_assistants_manager.h>
 #include <kis_3d_object_model.h>
-#include "kis_color_picker_utils.h"
 
 #define ENABLE_RECORDING
 static const int HIDE_OUTLINE_TIMEOUT = 800; // ms
 
 KisToolFreehand::KisToolFreehand(KoCanvasBase * canvas, const QCursor & cursor, const QString & transactionText)
     : KisToolPaint(canvas, cursor)
-    , m_dragDist(0)
     , m_transactionText(transactionText)
-    , m_mode(HOVER)
 {
+    m_explicitShowOutline = false;
+
+
     m_painter = 0;
     m_paintIncremental = false;
     m_executor = new QThreadPool(this);
@@ -112,13 +97,10 @@
     addAction("decrease_brush_size", m_decreaseBrushSize);
 
     KisCanvas2* canvas2 = static_cast<KisCanvas2*>(canvas);
-    connect(this, SIGNAL(sigFavoritePaletteCalled(const QPoint&)), canvas2, SIGNAL(favoritePaletteCalled(const QPoint&)));
     connect(this, SIGNAL(sigPainting()), canvas2->view()->resourceProvider(), SLOT(slotPainting()));
 
-    m_showOutline = false;
-    m_timer.setSingleShot(true);
-    connect(&m_timer, SIGNAL(timeout()), this, SLOT( hideOutline() ));
-
+    m_outlineTimer.setSingleShot(true);
+    connect(&m_outlineTimer, SIGNAL(timeout()), this, SLOT(hideOutline()));
 }
 
 KisToolFreehand::~KisToolFreehand()
@@ -132,271 +114,178 @@
     KisToolPaint::deactivate();
 }
 
+inline double norm(const QPointF& p)
+{
+    return sqrt(p.x()*p.x() + p.y()*p.y());
+}
+
+inline double angle(const QPointF& p1, const QPointF& p2)
+{
+    return atan2(p1.y(), p1.x()) - atan2(p2.y(), p2.x());
+}
+
 void KisToolFreehand::mousePressEvent(KoPointerEvent *e)
 {
-    if (currentPaintOpPreset() && currentPaintOpPreset()->settings()) {
-        m_paintIncremental = currentPaintOpPreset()->settings()->paintIncremental();
+    if(mode() == KisTool::PAINT_MODE)
+        return;
+
+    if(mode() == KisTool::HOVER_MODE &&
+       e->button() == Qt::LeftButton &&
+       e->modifiers() == Qt::NoModifier &&
+       !specialModifierActive()) {
+
         currentPaintOpPreset()->settings()->mousePressEvent(e);
         if (e->isAccepted()) {
             return;
         }
-    }
 
-    KisCanvas2 *canvas2 = dynamic_cast<KisCanvas2 *>(canvas());
-    if (canvas2->handlePopupPaletteIsVisible(e)) return;
+        setMode(KisTool::PAINT_MODE);
 
-    m_strokeTimeMeasure.start();
+        initPaint(e);
+        m_previousPaintInformation = KisPaintInformation(convertToPixelCoord(adjustPosition(e->point)),
+                                                         pressureToCurve(e->pressure()), e->xTilt(), e->yTilt(),
+                                                         KisVector2D::Zero(),
+                                                         e->rotation(), e->tangentialPressure(), m_strokeTimeMeasure.elapsed());
 
-    //    dbgUI << "mousePressEvent" << m_mode;
-    //     if (!currentImage())
-    //    return;
-    if (m_mode == PAN) {
-        e->accept();
-        return;
-    }
-    if (e->button() == Qt::MidButton) {
-        initPan();
-        e->accept();
-        return;
-    }
+        m_outlineDocPoint = e->point;
 
-    if (!currentNode())
-        return;
+        KisConfig cfg;
+        if(cfg.cursorStyle() == CURSOR_STYLE_OUTLINE) {
+            updateOutlineRect();
+        }
 
-    if (!currentNode()->paintDevice())
-        return;
-
-    // control-click gets the color at the current point. For now, only with a ratio of 1
-    // get the current color of the project, as per Deevad's suggestion.
-    // this shouldn't be changed back to the current node :-)
-    // CTRL+ALT picks color from current layer
-    // CTRL picks color from projection
-    if (e->modifiers() & Qt::ControlModifier) {
-
-        m_toForegroundColor = (e->button() == Qt::LeftButton);
-        pickColor(convertToIntPixelCoord(e),e->modifiers() & Qt::AltModifier);
-        m_mode = COLOR_PICKING;
-        useCursor(KisCursor::pickerCursor());
         e->accept();
-
-   } else if (e->modifiers() == Qt::ShiftModifier) {
-        m_mode = EDIT_BRUSH;
-        m_prevMousePos = e->point;
-        m_originalPos = e->globalPos();
-        m_originalMousePos = e->point;
-        e->accept();
-        return;
-    } else { // No modifiers
-
-        if (e->button() == Qt::LeftButton) {
-            initPaint(e);
-            m_previousPaintInformation = KisPaintInformation(convertToPixelCoord(adjustPosition(e->point)),
-                                                             pressureToCurve(e->pressure()), e->xTilt(), e->yTilt(),
-                                                             KisVector2D::Zero(),
-                                                             e->rotation(), e->tangentialPressure(), m_strokeTimeMeasure.elapsed());
-        } else if (m_mode == PAINT && (e->button() == Qt::RightButton || e->button() == Qt::MidButton)) {
-            // end painting, if calling the menu or the pop up palette. otherwise there is weird behaviour
-            endPaint();
-        }
     }
-    e->accept();
+    else {
+        KisToolPaint::mousePressEvent(e);
+    }
 }
 
-inline double norm(const QPointF& p)
-{
-    return sqrt(p.x()*p.x() + p.y()*p.y());
-}
-
-inline double angle(const QPointF& p1, const QPointF& p2)
-{
-    return atan2(p1.y(), p1.x()) - atan2(p2.y(), p2.x());
-}
-
 void KisToolFreehand::mouseMoveEvent(KoPointerEvent *e)
 {
-    //    dbgUI << "mouseMoveEvent " << m_mode << " " << e->button() << " " << e->buttons();
-    switch (m_mode) {
-    case PAINT: {
-            QPointF pos = convertToPixelCoord(adjustPosition(e->point));
-            QPointF dragVec = pos - m_previousPaintInformation.pos();
+    /**
+     * Update outline
+     */
+    if(mode() == KisTool::HOVER_MODE ||
+       mode() == KisTool::PAINT_MODE) {
+        m_outlineDocPoint = e->point;
 
-            KisPaintInformation info = KisPaintInformation(pos,
-                                                           pressureToCurve(e->pressure()), e->xTilt(), e->yTilt(),
-                                                           toKisVector2D(dragVec),
-                                                           e->rotation(), e->tangentialPressure(), m_strokeTimeMeasure.elapsed());
+        KisConfig cfg;
+        if(cfg.cursorStyle() == CURSOR_STYLE_OUTLINE) {
+            updateOutlineRect();
+        }
 
-            if (m_smooth) {
-                QPointF newTangent = dragVec;
-
-                if (norm(newTangent) != 0) {
-                    newTangent /= norm(newTangent) ;
-                }
-                double normVec = 0.5 * m_smoothness * norm(dragVec);
-                QPointF control1 = m_previousPaintInformation.pos() + m_previousTangent * normVec;
-                QPointF control2 = info.pos() - newTangent * normVec;
-                paintBezierCurve(m_previousPaintInformation,
-                                 control1,
-                                 control2,
-                                 info);
-                m_previousTangent = newTangent;
-                m_previousDrag = dragVec;
-            } else {
-                paintLine(m_previousPaintInformation, info);
+#if defined(HAVE_OPENGL)
+        else if (cfg.cursorStyle() == CURSOR_STYLE_3D_MODEL) {
+            if (isCanvasOpenGL()) {
+                m_xTilt = e->xTilt();
+                m_yTilt = e->yTilt();
+                // TODO : optimize? but you need to know the size of the 3d brush?
+                canvas()->updateCanvas(QRect(QPoint(0, 0), QSize(currentImage()->width(), currentImage()->height())));
             }
-
-            m_previousPaintInformation = info;
         }
-        break;
-    case EDIT_BRUSH: {
-            useCursor(KisCursor::blankCursor());
-            qreal dx = m_prevMousePos.x() - e->point.x();
-            qreal dy = m_prevMousePos.y() - e->point.y();
-            currentPaintOpPreset()->settings()->changePaintOpSize(-dx, -dy);
-            m_prevMousePos = e->point;
-        }
-        break;
-    case PAN: {
-            pan(e);
-        }
-        break;
-    case COLOR_PICKING:{
-            useCursor(KisCursor::pickerCursor());
-            if (e->modifiers() & Qt::ControlModifier) {
-                pickColor(convertToIntPixelCoord(e), e->modifiers() & Qt::AltModifier);
-            }else {
-                // DO Nothing
-            }
-
-        }
-        break;
-    default:
-        ;
+#endif
     }
 
-    KisConfig cfg;
-    KisPaintOpSettings::OutlineMode outlineMode;
-    if ((m_mode != PAINT  || cfg.showOutlineWhilePainting()) &&
-        (cfg.cursorStyle() == CURSOR_STYLE_OUTLINE || m_mode == EDIT_BRUSH || m_showOutline)) {
-        outlineMode = KisPaintOpSettings::CursorIsOutline;
-    } else {
-        outlineMode = KisPaintOpSettings::CursorIsNotOutline;
+    if(mode() != KisTool::PAINT_MODE) {
+        KisToolPaint::mouseMoveEvent(e);
+        return;
     }
 
-    if (!m_oldOutlineRect.isEmpty()) {
-        canvas()->updateCanvas(m_oldOutlineRect.adjusted(-2,-2,2,2)); // erase the old guy
-    }
+    /**
+     * Actual painting
+     */
+    QPointF pos = convertToPixelCoord(adjustPosition(e->point));
+    QPointF dragVec = pos - m_previousPaintInformation.pos();
 
-    m_mousePos = e->point;
+    KisPaintInformation info =
+        KisPaintInformation(pos, pressureToCurve(e->pressure()),
+                            e->xTilt(), e->yTilt(), toKisVector2D(dragVec),
+                            e->rotation(), e->tangentialPressure(),
+                            m_strokeTimeMeasure.elapsed());
 
-#if defined(HAVE_OPENGL)
-    if (cfg.cursorStyle() == CURSOR_STYLE_3D_MODEL) {
-        if (isCanvasOpenGL()) {
-            m_xTilt = e->xTilt();
-            m_yTilt = e->yTilt();
-            // TODO : optimize? but you need to know the size of the 3d brush?
-            canvas()->updateCanvas(QRect(QPoint(0, 0), QSize(currentImage()->width(), currentImage()->height())));
+    if (m_smooth) {
+        QPointF newTangent = dragVec;
+
+        if (norm(newTangent) != 0) {
+            newTangent /= norm(newTangent) ;
         }
+        double normVec = 0.5 * m_smoothness * norm(dragVec);
+        QPointF control1 = m_previousPaintInformation.pos() + m_previousTangent * normVec;
+        QPointF control2 = info.pos() - newTangent * normVec;
+        paintBezierCurve(m_previousPaintInformation,
+                         control1,
+                         control2,
+                         info);
+        m_previousTangent = newTangent;
+    } else {
+        paintLine(m_previousPaintInformation, info);
     }
-#endif
 
-
-    QPainterPath path;
-    if (m_painter && m_painter->paintOp()){
-        path = currentPaintOpPreset()->settings()->brushOutline(currentImage()->documentToPixel(outlinePos()), 
-                                                                         outlineMode,
-                                                                         m_painter->paintOp()->currentScale(),
-                                                                         m_painter->paintOp()->currentRotation());
-    }else{
-        path = currentPaintOpPreset()->settings()->brushOutline(currentImage()->documentToPixel(outlinePos()),outlineMode);
-    }
-    m_oldOutlineRect = currentImage()->pixelToDocument(path.boundingRect());
-    if (!m_oldOutlineRect.isEmpty()) {
-        canvas()->updateCanvas(m_oldOutlineRect.adjusted(-2,-2,2,2));
-    }
-
+    m_previousPaintInformation = info;
 }
 
 void KisToolFreehand::mouseReleaseEvent(KoPointerEvent* e)
 {
-    KisCanvas2 *canvas2 = dynamic_cast<KisCanvas2 *>(canvas());
-    if (canvas2->handlePopupPaletteIsVisible(e)) {
-        return;
-    }
-    else if (e->button() == Qt::LeftButton) {
-        //TODO: There is a bug here. If pop up palette is visible and a new colour is selected,
-        //the new colour will be added when the user clicks on the canvas to hide the palette
-        //This is used to handle recently used colour (KoFavoriteResourceManager)
-        emit sigPainting();
-    }
+    if(mode() == KisTool::PAINT_MODE &&
+       e->button() == Qt::LeftButton) {
 
-    switch (m_mode) {
-    case PAINT:
-        if (!m_hasPaintAtLeastOnce)
-        {
+        if (!m_hasPaintAtLeastOnce) {
             paintAt(m_previousPaintInformation);
+
+            // Let's add history information about recently used colors
+            emit sigPainting();
         }
-        endPaint();
-        break;
-    case PAN:
-        if (e->button() == Qt::MidButton) {
-            endPan();
-            e->accept();
-        }
-        return;
-    case EDIT_BRUSH:
-        QCursor::setPos(m_originalPos);
-        break;
-    default:
-        ;
-    };
 
-    if (m_mode != COLOR_PICKING){
+        setMode(KisTool::HOVER_MODE);
+        endPaint();
+        e->accept();
+    }
+    else {
         KisToolPaint::mouseReleaseEvent(e);
     }
-
-    m_mode = HOVER;
-    resetCursorStyle();
 }
 
 void KisToolFreehand::keyPressEvent(QKeyEvent *event)
 {
-    if (m_mode != HOVER) {
-        event->accept(); // Make sure nothing disturb the painting
+    if(mode() != KisTool::PAINT_MODE) {
+        KisToolPaint::keyPressEvent(event);
+        return;
     }
-    else if (event->key() == Qt::Key_Space) {
-        initPan();
-        event->accept();
-    }/* else if (event->key() == Qt::Key_Control){ // we need to reset the cursor back when the user does not hold any key so commented so far
-        useCursor(KisCursor::pickerCursor());
-    }*/else {
-        event->ignore();
-    }
+
+    event->ignore();
 }
 
 void KisToolFreehand::keyReleaseEvent(QKeyEvent* event)
 {
-    if (m_mode == PAN && event->key() == Qt::Key_Space) {
-        endPan();
-        event->accept();
+    if(mode() != KisTool::PAINT_MODE) {
+        KisToolPaint::keyReleaseEvent(event);
+        return;
     }
-    KoToolBase::keyReleaseEvent(event);
+
+    event->ignore();
 }
 
+void KisToolFreehand::gesture(const QPointF &offsetInDocPixels, const QPointF &initialDocPoint)
+{
+    currentPaintOpPreset()->settings()->changePaintOpSize(offsetInDocPixels.x(), offsetInDocPixels.y());
+
+    m_outlineDocPoint = initialDocPoint;
+
+    updateOutlineRect();
+}
+
 void KisToolFreehand::initPaint(KoPointerEvent *)
 {
     KisCanvas2 *canvas2 = dynamic_cast<KisCanvas2 *>(canvas());
     if(canvas2)
         canvas2->view()->disableControls();
 
-    //    dbgUI << "initPaint";
     if (!currentNode() || !currentNode()->paintDevice() || currentNode()->systemLocked())
         return;
 
     setCurrentNodeLocked(true);
-    
-    m_mode = PAINT;
     m_hasPaintAtLeastOnce = false;
-    m_dragDist = 0;
 
     KisPaintDeviceSP paintDevice = currentNode()->paintDevice();
     KisPaintDeviceSP targetDevice;
@@ -404,6 +293,8 @@
     if (!m_compositeOp)
         m_compositeOp = paintDevice->colorSpace()->compositeOp(COMPOSITE_OVER);
 
+    m_strokeTimeMeasure.start();
+    m_paintIncremental = currentPaintOpPreset()->settings()->paintIncremental();
 
     if (!m_paintIncremental) {
         KisIndirectPaintingSupport* indirect =
@@ -441,7 +332,6 @@
     }
 
     m_previousTangent = QPointF(0, 0);
-    m_previousDrag = QPointF(0, 0);
 
 
 #ifdef ENABLE_RECORDING // Temporary, to figure out what is going without being
@@ -457,13 +347,11 @@
 
 void KisToolFreehand::endPaint()
 {
-    //    dbgUI << "endPaint";
-
     KisCanvas2 *canvas2 = dynamic_cast<KisCanvas2 *>(canvas());
-    if(canvas2)
+    if(canvas2) {
         canvas2->view()->enableControls();
+    }
 
-    m_mode = HOVER;
     if (m_painter) {
 
         m_executor->waitForDone();
@@ -549,7 +437,7 @@
 
 void KisToolFreehand::setDirty(const QRegion& region)
 {
-    if (region.numRects() < 1)
+    if (region.isEmpty())
         return;
 
     currentNode()->setDirty(region);
@@ -569,7 +457,6 @@
     m_assistant = assistant;
 }
 
-#define ZET 7
 void KisToolFreehand::paint(QPainter& gc, const KoViewConverter &converter)
 {
     KisConfig cfg;
@@ -591,7 +478,7 @@
             }
 
             if (glIsList(m_displayList)) {
-                QPointF pos = converter.documentToView(m_mousePos);
+                QPointF pos = converter.documentToView(m_outlineDocPoint);
 
                 glColor3f(0.0, 1.0, 0.0);
                 glShadeModel(GL_SMOOTH);
@@ -646,32 +533,17 @@
 
     {
         KisPaintOpSettings::OutlineMode outlineMode;
-        if (m_mode == PAINT) {
-            m_showOutline = false;
-        }
+        outlineMode = KisPaintOpSettings::CursorIsNotOutline;
 
-        if ((m_mode != PAINT || cfg.showOutlineWhilePainting()) &&
-            (cfg.cursorStyle() == CURSOR_STYLE_OUTLINE || m_mode == EDIT_BRUSH || m_showOutline)) {
+        if(m_explicitShowOutline ||
+           mode() == KisTool::GESTURE_MODE ||
+           (cfg.cursorStyle() == CURSOR_STYLE_OUTLINE &&
+            (mode() != PAINT_MODE || cfg.showOutlineWhilePainting()))) {
+
             outlineMode = KisPaintOpSettings::CursorIsOutline;
-        } else {
-            outlineMode = KisPaintOpSettings::CursorIsNotOutline;
         }
 
-        qreal zoomX, zoomY;
-        converter.zoom(&zoomX, &zoomY);
-
-
-        QPainterPath path;
-        if (m_painter && m_painter->paintOp()){
-            path = currentPaintOpPreset()->settings()->brushOutline(currentImage()->documentToPixel(outlinePos()), 
-                                                                                outlineMode,
-                                                                                m_painter->paintOp()->currentScale(),
-                                                                                m_painter->paintOp()->currentRotation());
-        }else{
-            path = currentPaintOpPreset()->settings()->brushOutline(currentImage()->documentToPixel(outlinePos()),outlineMode);
-        }
-        m_oldOutlineRect = currentImage()->pixelToDocument(path.boundingRect());
-
+        QPainterPath path = getOutlinePath(m_outlineDocPoint, outlineMode);
         paintToolOutline(&gc,pixelToView(path));
     }
 }
@@ -685,46 +557,26 @@
     return point;
 }
 
-void KisToolFreehand::initPan()
+QPainterPath KisToolFreehand::getOutlinePath(const QPointF &documentPos,
+                                             KisPaintOpSettings::OutlineMode outlineMode)
 {
-    m_mode = PAN;
-    m_lastPosition = convertDocumentToWidget(m_mousePos);
-    useCursor(QCursor(Qt::ClosedHandCursor));
-}
+    qreal scale = 1.0;
+    qreal rotation = 0;
+    if (m_painter && m_painter->paintOp()){
+        scale = m_painter->paintOp()->currentScale();
+        rotation = m_painter->paintOp()->currentRotation();
+    }
 
-void KisToolFreehand::pan(KoPointerEvent *event)
-{
-    Q_ASSERT(canvas());
-    Q_ASSERT(canvas()->canvasController());
+    QPointF imagePos = currentImage()->documentToPixel(documentPos);
+    QPainterPath path = currentPaintOpPreset()->settings()->
+        brushOutline(imagePos, outlineMode, scale, rotation);
 
-    event->accept();
-
-    QPointF actualPosition = convertDocumentToWidget(event->point);
-    QPointF distance(m_lastPosition - actualPosition);
-    canvas()->canvasController()->pan(distance.toPoint());
-
-    m_lastPosition = actualPosition;
+    return path;
 }
 
-void KisToolFreehand::endPan()
-{
-    m_mode = HOVER;
-    resetCursorStyle();
-}
-
-void KisToolFreehand::customMoveEvent(KoPointerEvent * event)
-{
-    if (m_mode == PAN) {
-        canvas()->canvasController()->pan(QPoint(-event->x(), -event->y()));
-        event->accept();
-    }
-    event->ignore();
-}
-
 void KisToolFreehand::increaseBrushSize()
 {
     currentPaintOpPreset()->settings()->changePaintOpSize(1, 0);
-    m_oldOutlineRect.adjust(-1, -1, 1, 1);
     showOutlineTemporary();
 }
 
@@ -734,41 +586,27 @@
     showOutlineTemporary();
 }
 
-QPointF KisToolFreehand::outlinePos() const
+void KisToolFreehand::updateOutlineRect()
 {
-    if (m_mode == EDIT_BRUSH) {
-        return m_originalMousePos;
-    } else {
-        return m_mousePos;
-    }
+    QRectF outlinePixelRect = getOutlinePath(m_outlineDocPoint, KisPaintOpSettings::CursorIsOutline).boundingRect();
+    QRectF outlineDocRect = currentImage()->pixelToDocument(outlinePixelRect);
+
+#warning "Remove adjusted() call -- it smells hacky"
+    canvas()->updateCanvas(outlineDocRect.adjusted(-2,-2,2,2));
 }
 
 void KisToolFreehand::showOutlineTemporary()
 {
-    m_showOutline = true;
-    m_timer.start(HIDE_OUTLINE_TIMEOUT);
-    //canvas()->updateCanvas(m_oldOutlineRect);
-    canvas()->updateCanvas(QRect(QPoint(0, 0), QSize(currentImage()->width(), currentImage()->height())));
+    m_explicitShowOutline = true;
+    m_outlineTimer.start(HIDE_OUTLINE_TIMEOUT);
+    updateOutlineRect();
 }
 
 void KisToolFreehand::hideOutline()
 {
-    m_showOutline = false;
-    //canvas()->updateCanvas(m_oldOutlineRect);
-    canvas()->updateCanvas(QRect(QPoint(0, 0), QSize(currentImage()->width(), currentImage()->height())));
+    m_explicitShowOutline = false;
+    updateOutlineRect();
 }
 
-
-void KisToolFreehand::pickColor(const QPoint &pos, bool fromCurrentNode)
-{
-    int key = m_toForegroundColor ? KoCanvasResource::ForegroundColor : KoCanvasResource::BackgroundColor;
-    if (fromCurrentNode){
-            canvas()->resourceManager()->setResource(key,KisToolUtils::pick( currentNode()->paintDevice(),pos));
-    } else /* projection */{
-            canvas()->resourceManager()->setResource(key,KisToolUtils::pick( image()->projection(), pos));
-    }
-}
-
-
 #include "kis_tool_freehand.moc"
 
Index: ui/tool/kis_tool_paint.h
===================================================================
--- ui/tool/kis_tool_paint.h	(revision 1177751)
+++ ui/tool/kis_tool_paint.h	(working copy)
@@ -54,14 +54,6 @@
 
 class KisSliderSpinBox;
 
-enum enumBrushMode {
-    PAINT,
-    HOVER,
-    EDIT_BRUSH,
-    PAN,
-    COLOR_PICKING
-};
-
 // wacom 
 const static int LEVEL_OF_PRESSURE_RESOLUTION = 1024;
 
@@ -76,14 +68,20 @@
     virtual ~KisToolPaint();
 
 
-public:
+protected:
 
     virtual void resourceChanged(int key, const QVariant & v);
 
     virtual void paint(QPainter& gc, const KoViewConverter &converter);
 
+    virtual void mousePressEvent(KoPointerEvent *event);
     virtual void mouseReleaseEvent(KoPointerEvent *event);
+    virtual void mouseMoveEvent(KoPointerEvent *event);
 
+    virtual void keyPressEvent(QKeyEvent *event);
+    virtual void keyReleaseEvent(QKeyEvent* event);
+
+
     /** If the paint tool support outline like brushes, set to true.
     *   If not (e.g. gradient tool), set to false. Default is false.
     */
@@ -114,7 +112,8 @@
     qreal pressureToCurve(qreal pressure){
         return m_pressureSamples.at( qRound(pressure * LEVEL_OF_PRESSURE_RESOLUTION) );
     }
-    
+
+
 public slots:
     virtual void activate(ToolActivation toolActivation, const QSet<KoShape*> &shapes);
 
@@ -137,7 +136,11 @@
     QVector<qreal> m_pressureSamples;
 
 private:
+    void pickColor(const QPointF &documentPixel, bool fromCurrentNode,
+                   bool toForegroundColor);
 
+private:
+
     QGridLayout *m_optionWidgetLayout;
 
     QLabel *m_lbOpacity;
@@ -145,6 +148,11 @@
 
     bool m_supportOutline;
 
+    /**
+     * Used as a switch for pickColor
+     */
+    bool m_toForegroundColor;
+
 signals:
     void sigFavoritePaletteCalled(const QPoint&);
     void sigPainting();
Index: ui/tool/kis_tool_freehand.h
===================================================================
--- ui/tool/kis_tool_freehand.h	(revision 1177751)
+++ ui/tool/kis_tool_freehand.h	(working copy)
@@ -40,6 +40,16 @@
 class KisRecordedPathPaintAction;
 class FreehandPaintJobExecutor;
 
+#include "kis_paintop_settings.h"
+
+enum KDE_DEPRECATED enumBrushMode {
+    PAINT,
+    HOVER,
+    EDIT_BRUSH,
+    PAN,
+    COLOR_PICKING
+};
+
 class KRITAUI_EXPORT KisToolFreehand : public KisToolPaint
 {
 
@@ -51,21 +61,24 @@
     KisToolFreehand(KoCanvasBase * canvas, const QCursor & cursor, const QString & transactionText);
     virtual ~KisToolFreehand();
 
+    virtual void setDirty(const QRegion& region);
+
+signals:
+    void sigPainting();
+
+protected:
+    void gesture(const QPointF &offsetInDocPixels,
+                 const QPointF &initialDocPoint);
+
     virtual void mousePressEvent(KoPointerEvent *e);
     virtual void mouseMoveEvent(KoPointerEvent *e);
     virtual void mouseReleaseEvent(KoPointerEvent *e);
-    virtual void customMoveEvent(KoPointerEvent * event); // only for panning
     virtual void keyPressEvent(QKeyEvent *event);
     virtual void keyReleaseEvent(QKeyEvent* event);
     virtual bool wantsAutoScroll() const;
-    virtual void setDirty(const QRegion& region);
     virtual void deactivate();
 
-signals:
-    void sigPainting();
 
-protected:
-
     /// Paint a single brush footprint on the current layer
     virtual void paintAt(const KisPaintInformation &pi);
 
@@ -82,10 +95,6 @@
     virtual void endPaint();
     virtual void paint(QPainter& gc, const KoViewConverter &converter);
 
-    virtual void initPan();
-    virtual void pan(KoPointerEvent *e);
-    virtual void endPan();
-
 protected slots:
 
     void setSmooth(bool smooth);
@@ -98,18 +107,22 @@
     QPointF adjustPosition(const QPointF& point);
     void queuePaintJob(FreehandPaintJob* job, FreehandPaintJob* previousJob);
     void showOutlineTemporary();
-    void pickColor(const QPoint &pos, bool currentNode);
-    
-private slots:
 
+    void updateOutlineRect();
+    QPainterPath getOutlinePath(const QPointF &documentPos,
+                                KisPaintOpSettings::OutlineMode outlineMode);
+
+private slots:
     void increaseBrushSize();
     void decreaseBrushSize();
     void hideOutline();
 protected:
 
+    // For Dyna brush
+    QPointF m_outlineDocPoint;
+
     KisPaintInformation m_previousPaintInformation;
     QPointF m_previousTangent;
-    QPointF m_previousDrag;
     double m_dragDist;
 
     bool m_paintIncremental;
@@ -123,7 +136,6 @@
     double m_magnetism;
 
 private:
-    QPointF outlinePos() const;
 #if defined(HAVE_OPENGL)
     qreal m_xTilt;
     qreal m_yTilt;
@@ -135,34 +147,20 @@
     QString m_brushModelName;
 #endif
 
-    QPointF m_mousePos;
-    QPointF m_prevMousePos;
-    QPointF m_originalMousePos;
-    QPoint  m_originalPos;
+    QTimer m_outlineTimer;
+    bool m_explicitShowOutline;
 
-    // for painting
-    QRectF m_oldOutlineRect;
-    QPointF m_oldOutlinePosition;
-    
-    
     QRegion m_incrementalDirtyRegion;
     QList<FreehandPaintJob*> m_paintJobs;
     KisRecordedPathPaintAction* m_pathPaintAction;
     QThreadPool* m_executor;
 
-    // for panning
-    QPointF m_lastPosition;
     QTime m_strokeTimeMeasure;
 
     KAction* m_increaseBrushSize;
     KAction* m_decreaseBrushSize;
-    
+
     bool m_hasPaintAtLeastOnce; ///< this indicates whether mouseReleaseEvent should call paintAt or not
-    
-    QTimer m_timer;
-    bool m_showOutline;
-    
-    bool m_toForegroundColor;
 };
 
 
